﻿// NEXTW_PCIeSample_Cplusplus.cpp : 此檔案包含 'main' 函式。程式會於該處開始執行及結束執行。
//

#include <iostream>
#include "NEXTWPCIeLib.h"
using namespace std;

void ClearCmdData(transData* data)
{
	for (int i = 0; i < DEF_MA_MAX; i++)
	{
		data[i].CMD = data[i].Para = 0;
		data[i].Data1 = data[i].Data2 = 0;
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	int ret;
	bool isOpen = false;
	transData cmdData[DEF_MA_MAX], respData[DEF_MA_MAX];

	//Open PCIe Port
	ret = OpenECMPCIe();
	if (ret < 0)
	{
		cout << "Open PCIe Fail" << endl;
		return 0;
	}
	else
		isOpen = true;
		cout << "Open PCIe Success" << endl;
	Sleep(100);

	//Set State PreOP
	ClearCmdData(cmdData);
	ClearCmdData(respData);
	cmdData[0].CMD = SET_STATE;
	cmdData[0].Data1 = STATE_PRE_OP;
	ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret != 0)
		cout << "Write Error" << endl;

	//Set Axis
	ClearCmdData(cmdData);
	byte slaveType[] = //DRIVE, STEP, HSP, IO, None, total 64 axes
	{
		HSP, IO, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None,
		None, None, None, None, None, None, None, None
	};
	unsigned int topology;
	int j = 0;
	for (int i = 1; i <= 8; i++)
	{
		topology = 0;
		for (; j < i * 8; j++)
		{
			topology |= (slaveType[j] << (j % 8) * 4);
		}
		cmdData[0].CMD = SET_AXIS;
		cmdData[0].Para = i - 1; //Group
		cmdData[0].Data1 = topology;
		cmdData[0].Data2 = 0;
		ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
		if (!isOpen || ret != 0)
			cout << "Write Error" << endl;
		Sleep(2);
	}

	//Set DC
	ClearCmdData(cmdData);
	cmdData[0].CMD = SET_DC;
	cmdData[0].Para = 0;
	cmdData[0].Data1 = 2000; //Cycle time
	cmdData[0].Data2 = 0xFFFF;  //Fixed default value
	ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret != 0)
		cout << "Write Error" << endl;
	Sleep(2);

	//Set Drive Mode
	ClearCmdData(cmdData);
	for (int i = 1; i < DEF_MA_MAX - 1; i++)
	{
		if (slaveType[i - 1] == DRIVE || slaveType[i - 1] == HSP || slaveType[i - 1] == STEP)
		{
			cmdData[i].CMD = DRIVE_MODE;
			cmdData[i].Data1 = CSP_MODE; // set to CSP mode
			cmdData[i].Data2 = DCSYNC; // set using DC sync
		}
	}
	ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret != 0)
		cout << "Write Error" << endl;

	//Set State OP
	ClearCmdData(cmdData);
	cmdData[0].CMD = SET_STATE;
	cmdData[0].Data1 = STATE_OPERATIONAL;
	ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret < 0)
		cout << "Write Error" << endl;
	Sleep(2000);

	//Servo On
	ClearCmdData(cmdData);
	for (int i = 1; i < DEF_MA_MAX - 1; i++)
	{
		if (slaveType[i - 1] == DRIVE || slaveType[i - 1] == HSP || slaveType[i - 1] == STEP)  //set drive or HSP slave servo on
			cmdData[i].CMD = SV_ON;
	}
	ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret != 0)
		cout << "Write Error" << endl;

	//Set Output
	ClearCmdData(cmdData);
	for (int i = 1; i < DEF_MA_MAX - 1; i++)
	{
		if (slaveType[i - 1] == IO)
		{
			for (int j = 1; j <= 20; j++)
			{
				if (j % 2 == 1)
				{
					cmdData[i].CMD = IO_WR;
					cmdData[i].Data1 = 0x5555;
					cout << "0x5555" << endl;
					ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
					if (!isOpen || ret != 0)
						cout << "Write Error" << endl;
					Sleep(1000);
				}
				if (j % 2 == 0)
				{
					cmdData[i].CMD = IO_WR;
					cmdData[i].Data1 = 0xAAAA;
					cout << "0xAAAA" << endl;
					ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
					if (!isOpen || ret != 0)
						cout << "Write Error" << endl;
					Sleep(1000);
				}
			}
			cmdData[i].Data1 = 0xFFFF;
			cout << "0xFFFF" << endl;
			ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
			if (!isOpen || ret != 0)
				cout << "Write Error" << endl;
			Sleep(1000);
		}
	}
	Sleep(1000);

	//Read Current Position
	ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	int TargerPosition[DEF_MA_MAX];
	for (int i = 1; i < DEF_MA_MAX; i++)
	{
		TargerPosition[i] = respData[i].Data1;
	}

	//Set CSP(Cycle Synchronized Position)
	Sleep(1000);
	ClearCmdData(cmdData);
	ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	printf("Current Position: Slave 1 = %d, Slave 2 = %d, Slave 3 = %d.\n", respData[1].Data1, respData[2].Data1, respData[3].Data1);
	for (int i = 0; i < 1000; i++) // send 1000 times, let motor move 1000 * 100 pulse
	{
		for (int j = 1; j < DEF_MA_MAX - 1; j++)
		{
			if (slaveType[j - 1] == DRIVE || slaveType[j - 1] == HSP || slaveType[i - 1] == STEP) //Set drive or HSP slave Cycle Synchronized Position
			{
				TargerPosition[j] += 3;
				cmdData[j].CMD = CSP;
				cmdData[j].Data1 = TargerPosition[j]; // set to move 100 pulse in one cycle time
			}
		}
		ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
		if (!isOpen || ret != 0)
			printf("Write Error \n");

		ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
		if ((respData[0].Data2 % 65536) < 20)  // If FIFO remaining < 20 then sleep 10ms
			Sleep(10);
	}
	Sleep(3000); // wait until motion stop totally
	ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	printf("Current Position: Slave 1 = %d, Slave 2 = %d, Slave 3 = %d.\n", respData[1].Data1, respData[2].Data1, respData[3].Data1);

	//Set Servo off
	ClearCmdData(cmdData);
	for (int i = 1; i < DEF_MA_MAX - 1; i++)
	{
		if (slaveType[i - 1] == DRIVE || slaveType[i - 1] == HSP || slaveType[i - 1] == STEP) //Set drive or HSP slave servo off
			cmdData[i].CMD = SV_OFF;
	}
	ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret != 0)
		printf("Write Error \n");
	Sleep(100);

	//SET_STATE to Initial
	ClearCmdData(cmdData);
	cmdData[0].CMD = SET_STATE;
	cmdData[0].Data1 = STATE_INIT;
	ret = ECMPCIeWriteRead((unsigned char*)cmdData, (unsigned char*)respData);
	if (!isOpen || ret != 0)
		cout << "Write Error" << endl;
	Sleep(1000);

	//Close PCIe
	CloseECMPCIe();
	return 0;
}

// 執行程式: Ctrl + F5 或 [偵錯] > [啟動但不偵錯] 功能表
// 偵錯程式: F5 或 [偵錯] > [啟動偵錯] 功能表

// 開始使用的提示: 
//   1. 使用 [方案總管] 視窗，新增/管理檔案
//   2. 使用 [Team Explorer] 視窗，連線到原始檔控制
//   3. 使用 [輸出] 視窗，參閱組建輸出與其他訊息
//   4. 使用 [錯誤清單] 視窗，檢視錯誤
//   5. 前往 [專案] > [新增項目]，建立新的程式碼檔案，或是前往 [專案] > [新增現有項目]，將現有程式碼檔案新增至專案
//   6. 之後要再次開啟此專案時，請前往 [檔案] > [開啟] > [專案]，然後選取 .sln 檔案
