// PCIeSample_Cplusplus.cpp : wqDxε{iJIC
//
#include "stdafx.h"
#include "driver.h"

#define CYC_TIME			1000
#define TEST_DRIVE_CNT		4
#define TEST_IO_DEVICE_NO	3

int _tmain(int argc, _TCHAR* argv[])
{
	unsigned short usRet = 0;
	int nRet;
	int nValueBackup = 0;
	int nValueOut = 0;
	unsigned short slavefound = 0;
	int nPulseMap[64] = { 0 };
	int encoderValue[64] = { 0 };
	char bNetworkMap[64] = { 0 };	// 08:Drive CSP, 09: Drive CSV, 0x0A:Drive CST, 0x10:IO, Other None
	char bServoMap[64] = { 0 };		// 1: Servo On, 0: Servo Off , Other None
	char bMaskMap[64] = { 0 };		// 0 Mask(disable), Other enable
	char bIOMaskMap[64] = { 0 };	// 0 Mask(disable), Other enable
	int nOutputMap[64] = { 0 };
	char bHomeModeMap[64] = { 0 };
	int nHomeOffset[64] = { 0 };
	nRet = OpenDevice();
	if (nRet < 0) {
		printf("OpenDevice failed\n");
		return -1;
	}
	for (int i = 0; i < TEST_DRIVE_CNT; i++) {
		// 0x08 for Drive device CSP mode
		// 0x28 for HSP device CSP mode
		// 0x10 for IO device
		bNetworkMap[i] = 0x08;
	}
	nRet = Initialize(CYC_TIME, bNetworkMap, 1, &slavefound);
	if (nRet < 0) {
		printf("Initialize failed(%d)\n", nRet);
		return nRet;
	}
	printf("Initialize passed, %d slave(s) found.\n", slavefound);
	printf("Enter any key for SERVO-ON : ");
	getchar();	
	for (int i = 0; i < TEST_DRIVE_CNT; i++) {
		bServoMap[i] = 1;
	}
	SetServo(bServoMap);
	printf("Enter any key to start motion : ");
	getchar();
	nRet=ReadValue(encoderValue);
	printf("Target position is aligned with actual position :\n");
	for (int i = 0; i < TEST_DRIVE_CNT; i++) {
		nPulseMap[i] = encoderValue[i];
		bMaskMap[i] = 1;
		printf("Axis %d position : %d\n",i, nPulseMap[i]);
	}
	usRet = 80;
	for (int i = 0; i < 20000; i++){
		if(usRet < 10){		//	FIFO count threshold
			delay(2*CYC_TIME);
		}else{
			delay(CYC_TIME/2);
		}
		for(int j = 0; j < TEST_DRIVE_CNT; j++) {
			if (i < 200) {
				nPulseMap[j] += i;
			}else if (i >= 19800) {
				nPulseMap[j] -= (i - 20000);
			}else {
				nPulseMap[j] += 200;
			}
		}
		usRet = CSDataExchange(bMaskMap, nPulseMap);
	}
	printf("\nEnter any key to continue\n");
	getchar();
	nRet = ReadValue(encoderValue);
	for(int i=0;i< TEST_DRIVE_CNT;i++)
		printf("(%d) Encoder : %d , Command : %d , Diff : %d\n", i, encoderValue[i], nPulseMap[i], encoderValue[i] - nPulseMap[i]);
	printf("Enter any key to test SDO RD/WR\n");
	getchar();
	for (int i = 1; i <= TEST_DRIVE_CNT; i++) {
		printf("\n============\nSlave %d\n============\n",i);
		printf("SDO read from 0x607C:0\t=>");
		// SDO Read
		nRet = SDORead(i, 0x6099, 1, &nValueBackup);
		if (nRet <0)
			printf("\tSDORead Fail\n");
		else
			printf("\t%d\n", nValueBackup);
		printf("SDO write 1234 to 0x6099:1\n");
		// SDO Write
		SDOWrite(i, 0x6099, 1, 4, 1234);
		// SDO Read
		printf("SDO read from 0x6099:1\t=>");
		nRet = SDORead(i, 0x6099, 1, &nValueOut);
		if (nRet <0)
			printf("\tSDORead Fail\n");
		else
			printf("\t%d\n", nValueOut);
		// SDO Write
		printf("SDO write %d to 0x6099:1\n", nValueBackup);
		SDOWrite(i, 0x6099, 1, 4, nValueBackup);
	}
#ifdef TEST_IO_DEVICE
	printf("Enter any key to test IO device\n");
	getchar();
	// SetOutput	
	nOutputMap[TEST_IO_DEVICE_NO] = 0xAAAA;
	bIOMaskMap[TEST_IO_DEVICE_NO] = 1;
	CSDataExchange(bIOMaskMap, nOutputMap);
	printf("Set Output 0xAAAA\n");
	printf("Wait any key to continue\n");
	getchar();
	nOutputMap[TEST_IO_DEVICE_NO] = 0x5555;
	bIOMaskMap[TEST_IO_DEVICE_NO] = 1;
	CSDataExchange(bIOMaskMap, nOutputMap);
	printf("Set Output 0x5555\n");
#endif
	//GoHome
	printf("Enter any key to test GoHome\n");
	getchar();
	for (int i = 0; i < TEST_DRIVE_CNT; i++) {
		bMaskMap[i] = 1;
		bHomeModeMap[i] = 33;
		nHomeOffset[i] = 100;
	}
	GoHome(bMaskMap, bHomeModeMap, nHomeOffset);
	printf("Enter any key to continue\n");
	getchar();
	nRet = ReadValue(encoderValue);
	printf("After GoHome encoder value: ");
	for (int i = 0; i < TEST_DRIVE_CNT; i++) {
		printf("%d ", encoderValue[i]);
		bServoMap[i] = 0;
	}
	printf("Enter any key to Servo Off\n");
	getchar();
	// Servo Off
	SetServo(bServoMap);
	printf("\nServo Off\n");
	
	printf("Enter any key to Close Device\n");
	getchar();
	// CloseDevice
	CloseDevice();
	printf("CloseDevice\n");
	return 0;
}

