#include "stdafx.h"
#include <windows.h>
#include <winnt.h>
#include <stdio.h>
#include "crc_check.h"
#include "driver.h"
//#define ECM_EN_CRC 1
unsigned short	CMD_Phase[DEF_MA_MAX] = { 0 };
int     CMD_Pulse[DEF_MA_MAX] = { 0 };
int     CMD_Velocity[DEF_MA_MAX] = { 0 };
int     CMD_Torque[DEF_MA_MAX] = { 0 };
char     resqState = NIC_INIT;
unsigned int    Topology1 = 0;
unsigned int    CycleTime = 0;//us
unsigned int    DC_Offset = 0;//us
unsigned short    SDOch = 0;
unsigned int    CMDindex = 0;
unsigned int    CMDvalue = 0;
int     OP_Mode[DEF_MA_MAX] = { 0 };
int     DRIVE_TYPE[DEF_MA_MAX] = { 0 };
unsigned int	IO_Output[DEF_MA_MAX] = { 0 };
char  AxisGroup = 0;
int g_nCycTime = 0;
int g_nFifoCnt = 80;
struct {
	unsigned short 	CMD;
	unsigned short	CW;
	unsigned int	Data1;
	unsigned int	Data2;
} sbuff[DEF_MA_MAX], rbuff[DEF_MA_MAX];

void CMDBB_SW_RST()
{
	char i;
	CMD_Phase[0] = SW_RST;
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;
}

void CMDF0_GET_VER()
{
	char i;
	CMD_Phase[0] = GET_VER;
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;

}
void CMD00_NOP(unsigned short Channel)
{
	CMD_Phase[Channel] = NOP;
}

void CMD00_ALLNOP()
{
	for (int i = 0; i < DEF_MA_MAX; i++)
		CMD00_NOP(i);
}

void CMD01_SET_STATE(char state)
{
	char i;
	CMD_Phase[0] = SET_STATE;
	resqState = state;
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;
}

void CMD02_SET_AXIS(char Group, char* pTopology)
{
	char i;
	CMD_Phase[0] = SET_AXIS;
	AxisGroup = Group;
	Topology1 = (pTopology[7] << 28) | (pTopology[6] << 24) | (pTopology[5] << 20) | (pTopology[4] << 16) | (pTopology[3] << 12) | (pTopology[2] << 8) | (pTopology[1] << 4) | pTopology[0];
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;
}

void CMD03_SET_DC(unsigned int Time)
{
	char i;
	CMD_Phase[0] = SET_DC;
	CycleTime = Time;
	DC_Offset = 0xFFFF;
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;
}
void CMD05_ENABLE_CRC()
{
	char i;
	CMD_Phase[0] = ENABLE_CRC;
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;
}
void CMD04_DISABLE_CRC()
{
	char i;
	CMD_Phase[0] = DISABLE_CRC;
	for (i = 1; i < DEF_MA_MAX; i++)
		CMD_Phase[i] = NOP;
}
void CMD06_DRIVE_MODE(unsigned short Channel, unsigned short Mode, unsigned short Type)
{
	CMD_Phase[Channel] = DRIVE_MODE;
	OP_Mode[Channel] = Mode;
	DRIVE_TYPE[Channel] = Type;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD07_SDO_RD(unsigned short Channel, unsigned int Para)
{
	char i;
	CMD_Phase[DEF_MA_MAX - 1] = SDO_RD;
	SDOch = Channel;
	CMDindex = Para;
	for (i = 0; i < (DEF_MA_MAX - 1); i++)
		CMD_Phase[i] = NOP;
}

void CMD08_SDO_WR(unsigned short Channel, unsigned int Para, char Size, int Value)
{
	char i;
	CMD_Phase[DEF_MA_MAX - 1] = SDO_WR;
	SDOch = (Size << 8) | Channel;
	CMDindex = Para;
	CMDvalue = Value;
	for (i = 0; i < DEF_MA_MAX - 1; i++)
		CMD_Phase[i] = NOP;
}

void CMD10_ALMCLR(unsigned short Channel)
{
	CMD_Phase[Channel] = ALM_CLR;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD11_SVON(unsigned short Channel)
{
	CMD_Phase[Channel] = SV_ON;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD12_SVOFF(unsigned short Channel)
{
	CMD_Phase[Channel] = SV_OFF;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD13_IORD(unsigned short Channel)
{
	CMD_Phase[Channel] = IO_RD;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD14_IOWR(unsigned short Channel, unsigned int Output)
{
	CMD_Phase[Channel] = IO_WR;
	IO_Output[Channel] = Output;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD15_CSP(unsigned short Channel, int Pulse)
{
	CMD_Phase[Channel] = CSP;
	CMD_Pulse[Channel] = Pulse;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD16_CSV(unsigned short Channel, int Velocity)
{
	CMD_Phase[Channel] = CSV;
	CMD_Velocity[Channel] = Velocity;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD17_CST(unsigned short Channel, int Torque)
{
	CMD_Phase[Channel] = CST;
	CMD_Torque[Channel] = Torque;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void CMD18_GO_HOME(unsigned short Channel)
{
	CMD_Phase[Channel] = GO_HOME;
	CMD_Phase[0] = NOP;
	CMD_Phase[SDO_CH] = NOP;
}

void send_cmd_make(char MaxAxis)
{
	char i;
	for (i = 0; i < MaxAxis; i++)
	{
		switch (CMD_Phase[i])
		{
		case NOP://0x00
			sbuff[i].CMD = NOP;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case SET_STATE:	//0x01
			sbuff[i].CMD = SET_STATE;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = resqState;
			sbuff[i].Data2 = 0;
			break;

		case SET_AXIS:	//0x02
			sbuff[i].CMD = SET_AXIS;
			sbuff[i].CW = AxisGroup;
			sbuff[i].Data1 = Topology1;
			sbuff[i].Data2 = 0;//Topology2;
			break;

		case SET_DC:	//0x03
			sbuff[i].CMD = SET_DC;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = CycleTime;
			sbuff[i].Data2 = 0xFFFF;
			break;
		case DISABLE_CRC:	//0x04
			sbuff[i].CMD = DISABLE_CRC;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;
		case ENABLE_CRC:	//0x05
			sbuff[i].CMD = 04;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0x11;
			sbuff[i].Data2 = 0;
			break;

		case DRIVE_MODE:	//0x06
			sbuff[i].CMD = DRIVE_MODE;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = OP_Mode[i];
			sbuff[i].Data2 = DRIVE_TYPE[i];
			break;

		case SDO_RD:			//0x07
			sbuff[i].CMD = SDO_RD;
			sbuff[i].CW = SDOch;
			sbuff[i].Data1 = CMDindex;
			sbuff[i].Data2 = 0;
			break;

		case SDO_WR:			//0x08
			sbuff[i].CMD = SDO_WR;
			sbuff[i].CW = SDOch;
			sbuff[i].Data1 = CMDindex;
			sbuff[i].Data2 = CMDvalue;
			break;

		case ALM_CLR:			//0x10
			sbuff[i].CMD = ALM_CLR;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case SV_ON:			  //0x11
			sbuff[i].CMD = SV_ON;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case SV_OFF:			//0x12
			sbuff[i].CMD = SV_OFF;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case IO_RD:			  //0x13
			sbuff[i].CMD = IO_RD;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case IO_WR:		  	//0x14
			sbuff[i].CMD = IO_WR;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = IO_Output[i];
			sbuff[i].Data2 = 0;
			break;

		case CSP:			    //0x15
			sbuff[i].CMD = CSP;
			//sbuff[i].CW = 0;
			sbuff[i].Data1 = CMD_Pulse[i];
			//sbuff[i].Data2 = 0;
			break;

		case CSV:			    //0x16
			sbuff[i].CMD = CSV;
			//sbuff[i].CW = 0;
			sbuff[i].Data1 = CMD_Velocity[i];
			//sbuff[i].Data2 = 0;
			break;

		case CST:			    //0x17
			sbuff[i].CMD = CST;
			//sbuff[i].CW = 0;
			sbuff[i].Data1 = CMD_Torque[i];
			//sbuff[i].Data2 = 0;
			break;

		case GO_HOME:			  //0x18
			sbuff[i].CMD = GO_HOME;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case GET_VER:			    //0xF0
			sbuff[i].CMD = GET_VER;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		case SW_RST:			    //0xF0
			sbuff[i].CMD = SW_RST;
			sbuff[i].CW = 0;
			sbuff[i].Data1 = 0;
			sbuff[i].Data2 = 0;
			break;

		}
	}
}

void delay(int microsecond)
{
	if (microsecond <= 0)
		return;
	LARGE_INTEGER timerStrat, timerNow, Freq;
	QueryPerformanceFrequency(&Freq);
	QueryPerformanceCounter(&timerStrat);
	long long usecCount = Freq.QuadPart / 1000000;
	do
	{
		QueryPerformanceCounter(&timerNow);
	} while ((timerNow.QuadPart - timerStrat.QuadPart) < microsecond*usecCount);
}
static int g_nOld;
unsigned short data_exchange(unsigned char ucIdx = 0, unsigned char *pucReturnIdx = NULL)
{
	static unsigned short usFifoCnt = 80;
#ifdef ECM_EN_CRC
	unsigned short ucCRC;
	unsigned char crc_tmp;
	unsigned char crc_result;
#endif
	send_cmd_make(DEF_MA_MAX);
	sbuff[1].CMD |= (ucIdx << 8);
#ifdef ECM_EN_CRC
	sbuff[0].CW &= 0x00FF;
	ucCRC = cal_crc_table((unsigned char *)sbuff, DEF_MA_MAX * 3 * 4);
	sbuff[0].CW |= (ucCRC << 8);
#endif
	ECMPCIeWriteRead((unsigned char *)sbuff, (unsigned char*)rbuff);
#ifdef ECM_EN_CRC
	crc_tmp = (rbuff[0].CW >> 8);
	rbuff[0].CW &= 0x00FF;
	crc_result = cal_crc_table((unsigned char *)rbuff, DEF_MA_MAX * 3 * 4);
	if (crc_result != crc_tmp) {
		//printf("CRC failed : 0x%X vs 0x%X\n", crc_result, crc_tmp);
		return 0xFFFF;
	}
#endif
	if (pucReturnIdx != NULL)
		*pucReturnIdx = (rbuff[1].CMD >> 8);
	usFifoCnt = (rbuff[0].Data2 & 0xFFFF);
	return usFifoCnt;
}
int checkResponse(char slaves, char column, unsigned int expectValue, unsigned int retry)
{
	unsigned int realValue;
	unsigned int retried;
	unsigned int* g_au32DestinationData;
	g_au32DestinationData = (unsigned int*)rbuff;
	for (retried = 0; retried < retry; retried++)
	{
		if (column == 0)
			if (slaves == SDO_CH)
				realValue = g_au32DestinationData[(SPI_DG_LEN*slaves)];
			else
				realValue = g_au32DestinationData[(SPI_DG_LEN*slaves)] & 0xFF;
		else if (column == 1)
		{
			if (slaves == 0)
				realValue = (g_au32DestinationData[(SPI_DG_LEN*slaves)] >> 16) & 0xFF;
			else
				realValue = g_au32DestinationData[(SPI_DG_LEN*slaves)] >> 16;
		}
		else
			realValue = g_au32DestinationData[(SPI_DG_LEN*slaves + (column - 1))];

		if (realValue == expectValue)
		{
			break;
		}
		else if (retried == (retry - 1))
		{
			printf("checkResponse failed (0x%X, 0x%X)\n", realValue, expectValue);
		}
		else
		{
			delay(g_nCycTime);
			if (retried == 0) {
				CMD00_ALLNOP();
				send_cmd_make(DEF_MA_MAX);
			}
			ECMPCIeWriteRead((unsigned char *)sbuff, (unsigned char*)rbuff);
		}
	}
	return (realValue - expectValue);
}

int OpenDevice()
{
	return OpenECMPCIe();
}

void CloseDevice()
{
	CMD01_SET_STATE(STATE_INIT);
	data_exchange();
	CloseECMPCIe();
}

int Initialize(int nCycTime, char* bNetworkMap, int isDCEnable, unsigned short* slavefoundOut)
{
	unsigned char ucRet = 0;
	unsigned char ucIdx = 1;
	int i;
	char bTopolgy[64]; // 0:Drive, 1:IO, 2:HSP, 3:Step, Other None
	g_nFifoCnt = 80;
	printf("\n=================================================\n");
	//	OPTIONAL SETP - Set CRC enable
	//printf("OPTIONAL SETP - Set CRC enable : ");
	////CMD04_DISABLE_CRC();
	//CMD05_ENABLE_CRC();
	//ucIdx++;
	//for (i = 0; i < 80; i++) {
	//	data_exchange(ucIdx,&ucRet);
	//	if (ucRet == ucIdx) {
	//		break;
	//	}
	//	if (i == 79) {
	//		printf("FAILED(%d  !=  %d)\n", ucIdx, ucRet);
	//		return -1;
	//	}
	//}
	//printf("PASS\n");
	//	STEP 1 - SET_STATE to Init
	printf("STEP 1 - Set EtherCAT state to Init state : ");
	CMD01_SET_STATE(STATE_INIT);
	ucIdx++;
	for (i = 0; i < 80; i++) {
		data_exchange(ucIdx,&ucRet);
		if (ucRet == ucIdx) {
			break;
		}
		if (i == 79) {
			printf("FAILED(%d  !=  %d)\n", ucIdx, ucRet);
			return -2;
		}
	}
	printf("PASS\n");
	//	STEP 2 - SET_STATE to PreOP
	printf("STEP 2 - Set EtherCAT state to PreOP  state: ");
	CMD01_SET_STATE(STATE_PRE_OP);
	ucIdx++;
	for (i = 0; i < 80; i++) {
		data_exchange(ucIdx,&ucRet);
		if (ucRet == ucIdx) {
			break;
		}
		if (i == 79) {
			printf("FAILED\n");
			return -3;
		}
	}
	printf("PASS\n");
	//	STEP 3 - SET_AXIS
	printf("STEP 3 - Set network topology : ");
	for (i = 0; i < (DEF_MA_MAX - 2); i++)
	{
		if (bNetworkMap[i] <= 0x0F)
			bTopolgy[i] = DRIVE;
		else if (bNetworkMap[i] <= 0x1F)
			bTopolgy[i] = IO;
		else if (bNetworkMap[i] <= 0x2F)
			bTopolgy[i] = HSP;
	}
	for (i = 0; i < 8; i++)
	{
		CMD02_SET_AXIS(i, &bTopolgy[i * 8]);
		ucIdx++;
		for (int j = 0; j < 80; j++) {
			data_exchange(ucIdx,&ucRet);
			if (ucRet == ucIdx) {
				break;
			}
			if (j == 79) {
				printf("FAILED\n");
				return -4;
			}
		}
	}
	printf("PASS\n");
	*slavefoundOut = rbuff[0].Data1;
	//	STEP 4 - SET_DC
	printf("STEP 4 - Set timing parameter : ");
	g_nCycTime = nCycTime;
	CMD03_SET_DC(nCycTime);
	ucIdx++;
	for (i = 0; i < 80; i++) {
		data_exchange(ucIdx,&ucRet);
		if (ucRet == ucIdx) {
			break;
		}
		if (i == 79) {
			printf("FAILED\n");
			return -5;
		}
	}
	printf("PASS\n");
	//	STEP 5 - Set DRIVE_MODE
	printf("STEP 5 - Set DRIVE mode and DC type : ");
	for (i = 1; i < DEF_MA_MAX - 1; i++)
	{
		if (bNetworkMap[i - 1] <= 0x0F)
			CMD06_DRIVE_MODE(i, bNetworkMap[i - 1], isDCEnable ? DCSYNC : FREERUN);
		else if ((bNetworkMap[i - 1] >= 0x20) &( bNetworkMap[i - 1] <= 0x2F))
			CMD06_DRIVE_MODE(i, bNetworkMap[i - 1] - 0x20, isDCEnable ? DCSYNC : FREERUN);
	}
	ucIdx++;
	for (i = 0; i < 80; i++) {
		data_exchange(ucIdx,&ucRet);
		if (ucRet == ucIdx) {
			break;
		}
		if (i == 79) {
			printf("FAILED\n");
			return -6;
		}
	}
	printf("PASS\n");
	//	STEP 6 - SET_STATE to OP
	printf("STEP 6 - Set EtherCAT state to OP  state: ");
	CMD00_ALLNOP();
	CMD01_SET_STATE(STATE_OPERATIONAL);
	ucIdx++;
	for (i = 0; i < 80; i++) {
		data_exchange(ucIdx,&ucRet);
		if (ucRet == ucIdx) {
			break;
		}
		if (i == 79) {
			printf("FAILED\n");
			return -7;
		}
	}
	printf("PASS\n");
	//	Clear ALARM
	//printf("OPTIONAL STEP - Clear ALARM: ");
	//for (i = 1; i < DEF_MA_MAX - 1; i++)
	//	CMD10_ALMCLR(i);
	//ucIdx++;
	//for (int i = 0; i < 80; i++) {
	//	data_exchange(ucIdx,&ucRet);
	//	if (ucRet == ucIdx) {
	//		break;
	//	}
	//	if (i == 79) {
	//		printf("FAILED\n");
	//		return -1;
	//	}
	//}
	//printf("PASS\n");
	printf("=================================================\n\n");
	return 0;
}

void SetServo(char* bServoMap) //0 - Servo Off; 1 - Servo On
{
	char i;
	CMD00_ALLNOP();
	for (i = 1; i < DEF_MA_MAX - 1; i++)
		if (bServoMap[i - 1] == 0)
			CMD12_SVOFF(i);
		else if (bServoMap[i - 1] == 1)
			CMD11_SVON(i);
	data_exchange();
}

unsigned short CSDataExchange(char* pbMaskMap, int* pnTXD, int* pnRXD)
{
	unsigned short sRet;
	char i;
	for (i = 1; i < (DEF_MA_MAX - 1); i++)
		if (pbMaskMap[i - 1] != 0)
			CMD15_CSP(i, pnTXD[i - 1]);
	sRet = data_exchange();
	g_nFifoCnt = sRet;
	return sRet;
}
int GetEcmFifoCnt()
{
	return g_nFifoCnt;
}
void SetOutput(char* bMaskMap, unsigned int* iOutputMap)
{
	char i;
	CMD00_ALLNOP();
	for (i = 1; i < DEF_MA_MAX - 1; i++)
		if (bMaskMap[i - 1] != 0)
			CMD14_IOWR(i, iOutputMap[i - 1]);
	data_exchange();
}

int ReadValue(int* pnRXD)
{
	static unsigned char ucIdx = 1;
	unsigned char ucRet = 0;
	int i = 0;
	for (i = 0; i < 100; i++) {
		CMD00_ALLNOP();
		data_exchange(ucIdx,&ucRet);
		if (ucRet != ucIdx) {
			continue;
		}
		for (int j = 0; j < (DEF_MA_MAX - 2); j++) {
			pnRXD[j] = rbuff[j + 1].Data1;
		}
		break;
	}
	ucIdx++;
	if (i >= 99) {
		printf("ReadValue Error\n");
		return -1;
	}
	return 0;
}

int SDORead(unsigned short slave, unsigned short index, unsigned short subIndex, int* nValue)
{
	unsigned int para = (index << 16) + subIndex;
	unsigned int checkPara = (slave << 16) + 0x7;
	CMD07_SDO_RD(slave, para);
	data_exchange();
	if (checkResponse((DEF_MA_MAX - 1), 0, checkPara, 1000) == 0) {
		if (checkResponse((DEF_MA_MAX - 1), 2, para, 1000) == 0)
		{
			*nValue = rbuff[(DEF_MA_MAX - 1)].Data2;
			return 0;
		}
	}
	return -1;
}

int SDOWrite(unsigned short slave, unsigned short index, unsigned short subIndex, char objectSize, int value)
{
	unsigned int para = (index << 16) + subIndex;
	unsigned int checkPara = (slave << 16) + 0x8;
	CMD08_SDO_WR(slave, para, objectSize, value);
	data_exchange();
	if (checkResponse((DEF_MA_MAX - 1), 0, checkPara, 100) == 0) {
		if (checkResponse((DEF_MA_MAX - 1), 2, para, 100) == 0)
		{
			return 0;
		}
	}
	return -1;
}

void ResetMotionCard()
{
	CMDBB_SW_RST();
	data_exchange();
}

void GoHome(char* bEnableMap, char* bHomeModeMap, int* nHomeOffset)
{
	for (int i = 1; i < DEF_MA_MAX - 1; i++) {
		if (bEnableMap[i - 1] != 0) {
			SDOWrite(i, 0x6060, 0, 1, 6);
			SDOWrite(i, 0x6098, 0, 1, bHomeModeMap[i - 1]);
			SDOWrite(i, 0x607C, 0, 4, nHomeOffset[i - 1]);
		}
	}
	CMD00_ALLNOP();
	for (int i = 1; i < DEF_MA_MAX - 1; i++) {
		if (bEnableMap[i - 1] != 0) {
			CMD18_GO_HOME(i);
		}
	}
	data_exchange();
}