#include "NEXTWPCIeLib.h"
#define DEF_MA_MAX   66
#define SPI_DG_LEN   3
#define TEST_COUNT (SPI_DG_LEN*DEF_MA_MAX)
#define SDO_CH     (DEF_MA_MAX-1)

#define NOP         0x00
#define SET_STATE   0x01
#define SET_AXIS    0x02
#define SET_DC      0x03
#define DISABLE_CRC 0x04
#define ENABLE_CRC  0x05
#define DRIVE_MODE  0x06
#define SDO_RD      0x07
#define SDO_WR      0x08
#define HOME_MODE   0x09

#define ALM_CLR     0x10
#define SV_ON       0x11
#define SV_OFF      0x12
#define IO_RD       0x13
#define IO_WR       0x14
#define CSP         0x15
#define CSV         0x16
#define CST         0x17
#define GO_HOME     0x18

#define SW_RST		0xBB
#define GET_VER     0xF0

#define FREERUN     0x00
#define DCSYNC      0x01

#define DRIVE        0
#define IO           1
#define HSP          2
#define None         0xFF

#define HOMING_MODE    6
#define CSP_MODE       0x08
#define CSV_MODE       0x09
#define CST_MODE       0x0A
enum
{
   NIC_INIT             = 0x00,
	 /** Init state*/
   STATE_INIT           = 0x01,
   /** Pre-operational. */
   STATE_PRE_OP         = 0x02,
   /** Safe-operational. */
   STATE_SAFE_OP        = 0x04,
   /** Operational */
   STATE_OPERATIONAL    = 0x08,
};
int OpenDevice();
void CloseDevice();
int Initialize(int nCycTime, char* bNetworkMap,int isDCEnable, unsigned short* slavefoundOut);
void SetServo(char* bServoMap);
unsigned short CSDataExchange(char* pbMaskMap, int* pnTXD, int* pnRXD=NULL);
void SetOutput(char* bMaskMap, unsigned int* iOutputMap);
int ReadValue(int* pnRXD);
int SDORead(unsigned short slave, unsigned short index, unsigned short subIndex, int* nValue);
int SDOWrite(unsigned short slave,unsigned short index,unsigned short subIndex,char objectSize, int value);
void ResetMotionCard();
void GoHome(char* bMaskMap, char* bHomeModeMap, int* nHomeOffset);
void delay(int microsecond);