﻿' STEP 1 - Add reference - NEXTWPCIe_dotNET_12B.dll
' STEP 2 Imports NEXTWPCIe_dotNET_12B
Imports NEXTWPCIe_dotNET
Module Module1
    Function checkResponse(slaves As UInteger, column As UInteger, expectValue As UInteger, retry As UInteger) As Boolean
        Dim realValue As UInteger
        Dim retried As UInteger
        realValue = 987654321 'inital data
        For i As Integer = 0 To retry
            NEXTWPCIe.ECMPCIeRead()
            If (column = 0) Then
                If (slaves = 41) Then
                    realValue = NEXTWPCIe.respData(slaves).CMD
                Else
                    realValue = (NEXTWPCIe.respData(slaves).CMD & &HFFFF)
                End If
            ElseIf (column = 1) Then
                If (slaves = 0) Then
                    realValue = (NEXTWPCIe.respData(slaves).Parm & &HFF)
                Else
                    realValue = (NEXTWPCIe.respData(slaves).Parm)
                End If
            ElseIf (column = 2) Then
                realValue = (NEXTWPCIe.respData(slaves).Data1)
            ElseIf (column = 3) Then
                realValue = (NEXTWPCIe.respData(slaves).Data2)
            End If

            If (realValue = expectValue) Then
                Exit For
            ElseIf (retry = retried) Then
                Console.WriteLine("Fail,realValue= " + realValue.ToString() + " expectValue= " + expectValue.ToString() + " retry = " + retried.ToString())
            Else
                'NEXTWPCIe.ClearCmdData()
                NEXTWPCIe.ECMPCIeRead()
            End If
        Next
        System.Threading.Thread.Sleep(1)  ' wait
        Return (realValue = expectValue)
    End Function

    Sub Main()
        Dim retValue As Integer
        Dim isOpen As Boolean
        ' STEP 3 - Open the PCIe Port
        retValue = NEXTWPCIe.OpenECMPCIe()
        If retValue = 0 Then
            isOpen = True
        Else
            Console.WriteLine("Open PCIe Fail")
            Return
        End If
        System.Threading.Thread.Sleep(100)

        ' STEP 4 - SET_STATE to PreOP
        NEXTWPCIe.ClearCmdData()
        NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.SET_STATE
        NEXTWPCIe.cmdData(0).Data1 = NEXTWPCIe.STATE_PRE_OP ' set state to pre-OP
        retValue = NEXTWPCIe.ECMPCIeWriteRead()
        If (Not isOpen OrElse retValue <> 0) Then Console.WriteLine("Write Error")
        checkResponse(0, 1, 2, 100)

        'STEP 5 - SET_AXIS
        NEXTWPCIe.ClearCmdData()
        Dim slaveType() As Char = {"p"c, "i"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c,
                                   "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c, "n"c}
        Dim topology As UInt32
        For i As Integer = 1 To 8
            topology = 0
            For j As Integer = (i - 1) * 8 To (i * 8) - 1
                Select Case slaveType(j)
                    '  Case "d"c  ' "d"c means drive
                    Case "i"c  ' "i"c means io
                        topology += Math.Pow(16, j)
                    Case "p"c  ' "p"c means High Speed Pulse (HSP)
                        topology += Math.Pow(16, j) * 2
                    Case "s"c  ' "s"c means Step
                        topology += Math.Pow(16, j) * 3
                End Select
            Next
            NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.SET_AXIS
            NEXTWPCIe.cmdData(0).Parm = (i - 1) ' Group 
            NEXTWPCIe.cmdData(0).Data1 = topology
            NEXTWPCIe.cmdData(0).Data2 = 0
            If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
            System.Threading.Thread.Sleep(2)
        Next

        'STEP 6 - SET_DC
        NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.SET_DC
        NEXTWPCIe.cmdData(0).Parm = 0
        NEXTWPCIe.cmdData(0).Data1 = 2000 ' set cycle time to 2000 us
        NEXTWPCIe.cmdData(0).Data2 = &HFFFF ' Auto offet adjustment
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(2)

        ' STEP 7 - Set DRIVE_MODE
        NEXTWPCIe.ClearCmdData()
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "d"c OrElse slaveType(i - 1) = "p"c OrElse slaveType(i - 1) = "s"c) Then
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.DRIVE_MODE
                NEXTWPCIe.cmdData(i).Data1 = NEXTWPCIe.CSP_MODE ' set to CSP mode
                NEXTWPCIe.cmdData(i).Data2 = NEXTWPCIe.DCSYNC ' set using DC sync
            End If
        Next
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(2)

        ' STEP 8 - SET_STATE to SafeOP (This step could be skipped)
        NEXTWPCIe.ClearCmdData()
        NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.SET_STATE
        NEXTWPCIe.cmdData(0).Data1 = NEXTWPCIe.STATE_SAFE_OP  ' // set state to Safe-OP
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        checkResponse(0, 1, 4, 1000)  ' wait for enter to safe op mode

        ' STEP 9 - SET_STATE to OP
        NEXTWPCIe.ClearCmdData()
        NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.SET_STATE
        NEXTWPCIe.cmdData(0).Data1 = NEXTWPCIe.STATE_OPERATIONAL ' set state to OP
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        checkResponse(0, 1, 8, 1000) 'wait for enter to op mode


        ' STEP 10 - SET Servo On
        NEXTWPCIe.ClearCmdData()
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "d"c OrElse slaveType(i - 1) = "p"c OrElse slaveType(i - 1) = "s"c) Then 'set drive or HSP slave servo on
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.SV_ON
            End If
        Next
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(400)  ' wait for servo on 

        ' STEP 11- Read Current Position
        NEXTWPCIe.ECMPCIeRead()
        Dim TargerPosition(NEXTWPCIe.DEF_MA_MAX) As Integer
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            Dim temp = BitConverter.GetBytes((NEXTWPCIe.respData(i).Data1))
            TargerPosition(i) = BitConverter.ToInt32(temp, 0) ' Change UInt to Int32
        Next

        ' STEP 12- SET Cycle Synchronized Position
        System.Threading.Thread.Sleep(1000) ' wait until motion stop totally
        'NEXTWPCIe.ClearCmdData()
        NEXTWPCIe.ECMPCIeRead()
        Console.WriteLine("Current Position: Slave 1 = " + NEXTWPCIe.respData(1).Data1.ToString() +
            " Slave 2 = " + NEXTWPCIe.respData(2).Data1.ToString() + ", Slave 3 = " + NEXTWPCIe.respData(3).Data1.ToString())
        For i As Integer = 1 To 1000     'send 1000 times, let motor move 1000 * 100 pulse
            For j As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
                If (slaveType(j - 1) = "d"c OrElse slaveType(j - 1) = "p"c OrElse slaveType(j - 1) = "s"c) Then 'Set drive or HSP slave Cycle Synchronized Position
                    TargerPosition(j) += 3 ' set to move 100 pulse in one cycle time
                    NEXTWPCIe.cmdData(j).CMD = NEXTWPCIe.CSP
                    Dim temp = BitConverter.GetBytes(TargerPosition(j))
                    NEXTWPCIe.cmdData(j).Data1 = BitConverter.ToUInt32(temp, 0) ' Change Int32 to UInt
                End If
            Next

            If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
            ' NEXTWPCIe.ECMPCIeRead()
            If ((NEXTWPCIe.respData(0).Data2 Mod 65536) < 20) Then ' If FIFO remaining < 20 then sleep 10ms
                System.Threading.Thread.Sleep(10)
            End If
        Next
        System.Threading.Thread.Sleep(3000)  ' wait until motion stop totally
        NEXTWPCIe.ECMPCIeRead()
        Console.WriteLine("Current Position: Slave 1 = " + NEXTWPCIe.respData(1).Data1.ToString() +
            " Slave 2 = " + NEXTWPCIe.respData(2).Data1.ToString() + ", Slave 3 = " + NEXTWPCIe.respData(3).Data1.ToString())

        ' STEP 13- SET Servo Off
        NEXTWPCIe.ClearCmdData()
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "d"c OrElse slaveType(i - 1) = "p"c OrElse slaveType(i - 1) = "s"c) Then 'Set drive or HSP slave servo off
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.SV_OFF
            End If
        Next
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(100)

        ' STEP 14- Read Input
        NEXTWPCIe.ClearCmdData()
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "i"c) Then 'IO slave can read input
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.IO_RD
            End If
        Next
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(10)
        NEXTWPCIe.ECMPCIeRead()
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "i"c) Then 'IO slave can read input
                Console.WriteLine("Current Position: Slave " + i.ToString() + " = " + NEXTWPCIe.respData(i).Data1.ToString())
            End If
            If (slaveType(i - 1) = "p"c) Then 'HSP slave can read input
                Console.WriteLine("Current Position: Slave " + i.ToString() + " = " + (NEXTWPCIe.respData(i).Data2 And &HFF).ToString())
            End If
        Next
        System.Threading.Thread.Sleep(100)

        ' STEP 15- Write Output
        NEXTWPCIe.ClearCmdData()
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "i"c) Then ' IO slave can set Output
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.IO_WR
                NEXTWPCIe.cmdData(i).Data1 = &HFFFF
            End If
            If (slaveType(i - 1) = "p"c) Then ' HSP slave can set Output
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.CSP
                NEXTWPCIe.cmdData(i).Data2 = NEXTWPCIe.cmdData(i).Data2 Or &HFF
            End If
        Next
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(5000)
        NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.LIO_WR 'ECM can set Local Output
        NEXTWPCIe.cmdData(0).Data1 = &H0  'Output Value
        For i As Integer = 1 To NEXTWPCIe.DEF_MA_MAX - 2
            If (slaveType(i - 1) = "i"c) Then 'only drive slave can set servo off
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.IO_WR
                NEXTWPCIe.cmdData(i).Data1 = &H0
            End If
            If (slaveType(i - 1) = "p"c) Then ' HSP slave can set Output
                NEXTWPCIe.cmdData(i).CMD = NEXTWPCIe.CSP
                NEXTWPCIe.cmdData(i).Data2 = NEXTWPCIe.cmdData(i).Data2 And &HFF00
            End If
        Next
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        System.Threading.Thread.Sleep(1000)

        ' SETP 16- SET_STATE to Init
        NEXTWPCIe.ClearCmdData()
        NEXTWPCIe.cmdData(0).CMD = NEXTWPCIe.SET_STATE
        NEXTWPCIe.cmdData(0).Data1 = NEXTWPCIe.STATE_INIT
        If (Not isOpen OrElse NEXTWPCIe.ECMPCIeWriteRead() <> 0) Then Console.WriteLine("Write Error")
        checkResponse(0, 1, 1, 1000)
        ' STEP 17- Close PCIe
        NEXTWPCIe.CloseECMPCIe()
    End Sub
End Module
